/*

Target MCU   : ATML (AT90CAN64)
XTAL         : 16Mhz
Uart Bitrate : 115200 bps

 α׷ NT-ARSv1   α׷Դϴ.

NT-ARSv1 Serial to Can  ޽ ,

NT-ARSv1κ ͸ ޾ ó  Serial  Ͱ ϴ α׷Դϴ.

  α׷ NT-ARSv1  ϴ   ۵  α׷ ̸,

ܼ  Ͻñ ٶϴ.

*/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdio.h>


#define EXTENDED            1
#define FILE_OPEN	0x01
#define FILE_CLOSE	0x02

static FILE* fp;
static unsigned char fp_flag = FILE_CLOSE;

char uart_rx_data;
struct CanMsg{
    unsigned char RX_DataBuf[8];
    unsigned char TX_DataBuf[8];
    unsigned char DataLength;
    unsigned char MODE;
    unsigned long ID;
}CanMsg;

unsigned char g_NT_ARSv1_StartFlag;
volatile unsigned char gc_CanCalculationFlag;
char gc_CanBuf[8];

double gd_Roll;
double gd_Pitch;
double gd_GyroX;
double gd_GyroY;

unsigned int gi_RollBuf=0;
unsigned int gi_PitchBuf=0;
unsigned int gi_GyroX_Buf=0;
unsigned int gi_GyroY_Buf=0;


char CAN_Transmit(unsigned char n_MOb, unsigned long n_MSG_ID);
unsigned char can_receive(unsigned char n_MOb);	// CAN RX

int u1_PutChar(unsigned char data)
{
    if( data == '\n')
    u1_PutChar('\r');
    loop_until_bit_is_set(UCSR1A, UDRE1);
    UDR1 = data;
    return 0;
}

char u1_GetChar(void)
{
    while( !(UCSR1A & (1<<RXC1)) );		//Wait for data to be received
    return UDR1;						// Get and return received data from buffer
}
int main(void)
{

    char n_num_channel, n_num_data;
    unsigned long n_MSG_ID = 0x00000002;
    unsigned long n_MASK_ID = 0x1fffffff;

    //UART Init


    UCSR1A = 0x00;
    UCSR1B = (1<<RXCIE1) | (1<<RXEN1)|(1<<TXEN1);
    UCSR1C = (0<<UMSEL1) | (0<<UPM1) | (0<<USBS1) | (1<<UCSZ11) | (1<<UCSZ10);
    UBRR1H = 8 >> 8;
    UBRR1L = 8;
    DDRD |= 0x08;
    PORTD = 0x08;


	if(fp_flag == FILE_OPEN)
		fclose(fp);
    FILE* fp;    
	fp = fdevopen(u1_PutChar, u1_GetChar);
	fp_flag = FILE_OPEN;


    //can init
    CANGCON |= (1<<SWRES);
    CANTCON = 0;

    for(n_num_channel=0;n_num_channel<15;n_num_channel++) {
		//CAN Page MOb Register
		CANPAGE  = n_num_channel<<4;	// channel,/AINC=0,IDX=0 	bit 7:4 - MOBNB3:0: MOb Number
		//available numbers are from 0 to 14.
		
		//CAN MOb Status Register
		CANSTMOB = 0;   //clear status		
		CANCDMOB = 0;   //all disable
		//CAN Identifier Tag Registers
		CANIDT1  = 0;
		CANIDT2  = 0;
		CANIDT3  = 0;
		CANIDT4  = 0;
		//CAN Identifier Mask Registers
		CANIDM1  = 0;
		CANIDM2  = 0;
		CANIDM3  = 0;
		CANIDM4  = 0;

	   for(n_num_data=0;n_num_data<8;n_num_data++)	// CANPAGE.3 = 0
	      CANMSG = 0;						// Auto increment mode
	}

    CANBT1 = 0x06;			CANBT2 = 0x04;			CANBT3 = 0x13;  //500Khz TQ(0.250us)

    CANGCON |= (1<<ENASTB);		// CAN Controller Enable

    //CAN Page MOb Register
	CANPAGE  = 1<<4;		// channel,/AINC=0,IDX=0 Bit 7:4 . MOBNB3:0: MOb Number
	
	//CAN MOb Status Register
	CANSTMOB  = 0x00;

    // extended: 29bit identifier
    //CAN MOb Control and DLC Register
    CANCDMOB = 0x10;		// IDE = 1;
    CANIDT1 = (unsigned char)(n_MSG_ID>>21);
    CANIDT2 = (unsigned char)(n_MSG_ID>>13);
    CANIDT3 = (unsigned char)(n_MSG_ID>>5);
    CANIDT4 = (unsigned char)(n_MSG_ID<<3);

    CANIDM1 = (unsigned char)(n_MASK_ID>>21);
    CANIDM2 = (unsigned char)(n_MASK_ID>>13);
    CANIDM3 = (unsigned char)(n_MASK_ID>>5);
    CANIDM4 = (unsigned char)(n_MASK_ID<<3);

	CANIDT4 &= ~0x04;			// RTRTAG = 0
	CANIDM4 &= ~0x04;			// RTRMSK = 0

	//CAN MOb Control and DLC Register
	CANCDMOB |= 0x88;			// Receiver,DLC=8
	//CONMOB1:0: Configuration of Message Object // .10 - enable reception.
	//Bit 3:0 . DLC3:0: Data Length Code
	
	//CAN Enable Interrupt MOb Registers -

	CANIE2 |= (1<<1);// Enable IECH
	
    CANGIE |= (1<<ENIT);		// Enable all interrupt(Except for Timer Overrun Interrupt)
    CANGIE |= (1<<ENRX);		// ENRX: Enable Receive Interrupt

    CANEN1 = 0xFF;
    CANEN2 = 0xFF;				// Bits 14:0 - ENMOB14:0: Enable MOb

    //CAN MSG SET

    sei();
    //_delay_ms(100);
    //printf("hi");

    while(1)
    {
        if(gc_CanCalculationFlag == 1)
        {
            gc_CanCalculationFlag = 0;
            printf("R:%1.2f, P:%1.2f \r\n",gd_Roll,gd_Pitch);
        }
    }
}

char CAN_Transmit(unsigned char n_MOb, unsigned long n_MSG_ID)	// CAN TX
{
    unsigned char n_send_result = 0;
    unsigned char n_buff_CNT;  
    unsigned int i;

	CANPAGE  = n_MOb<<4;		// channel,/AINC=0,IDX=0 Bit 7:4 . MOBNB3:0: MOb Number


	CANSTMOB = 0x00;

	CANCDMOB = 0x00;				// CONMOB=00,RPLV=0,IDE=0,DLC=0000
	
    	// extended: 29bit identifier
    CANIDT1 = (unsigned char)(n_MSG_ID>>21);
    CANIDT2 = (unsigned char)(n_MSG_ID>>13);
    CANIDT3 = (unsigned char)(n_MSG_ID>>5);
    CANIDT4 = (unsigned char)(n_MSG_ID<<3);

    CANCDMOB |= (1<<IDE);				// IDE = 1 (2.0B)

    for(n_buff_CNT = 0; n_buff_CNT<CanMsg.DataLength; n_buff_CNT++)		// CANPAGE.3 = 0
    CANMSG = CanMsg.TX_DataBuf[n_buff_CNT];
	
	CANCDMOB |= CanMsg.DataLength;		// configure data length 
	CANCDMOB |= (1<<CONMOB0);				//enable transmit..
	
	
	for(i=0 ;i<100;i++){		// wait 100 msec
	   if((CANSTMOB & 0x40) != 0x00){		//TXOK 1?
	      n_send_result = 1;
	   	 break;
	   }
	   //_delay_ms(1);
	}
	
	CANCDMOB = 0x00;				// CONMOB=00,RPLV=0,IDE=0,DLC=0000
	
	return(n_send_result);
}


unsigned char can_receive(unsigned char n_MOb)	// CAN RX
{
	unsigned char n_receive_result = 0;
	unsigned char n_buff_CNT;  
	unsigned long n_can_id = 0;

	CANPAGE  = n_MOb<<4;			// channel,/AINC=0,IDX=0

	if((CANSTMOB & 0x20) != 0x00) {		// RXOK != 0

		CanMsg.MODE = EXTENDED;
		n_can_id  = ((unsigned long)CANIDT1)<<24;
		n_can_id |= ((unsigned long)CANIDT2)<<16;
		n_can_id |= ((unsigned long)CANIDT3)<<8;
		n_can_id |= ((unsigned long)CANIDT4);
		n_can_id >>= 3;
		
		CanMsg.ID = n_can_id;
		CanMsg.DataLength = CANCDMOB & 0x0F;		// DLC[3:0]

        for(n_buff_CNT = 0; n_buff_CNT< 8; n_buff_CNT++ )
        CanMsg.RX_DataBuf[n_buff_CNT] = 0x00;

		for(n_buff_CNT = 0; n_buff_CNT<CanMsg.DataLength; n_buff_CNT++)		// CANPAGE.3 = 0
			CanMsg.RX_DataBuf[n_buff_CNT] = CANMSG;		// Auto increment mode
		n_receive_result = 1;
	}

	CANSTMOB = 0x00;
	CANCDMOB  = 0x10;			// rev 2.0 B
	CANCDMOB  |= 0x88;				// Receiver,DLC=8
	
	return(n_receive_result);
}


SIGNAL(SIG_UART1_RECV)
{
    uart_rx_data = UDR1;

    //CAN_Transmit(2,0x00000001,uart_rx_data);

    if(uart_rx_data == 'c')
    {
        //printf("c\r\n");
        g_NT_ARSv1_StartFlag = 1;
        CanMsg.DataLength = 5;
        CanMsg.TX_DataBuf[0] = '<';
        CanMsg.TX_DataBuf[1] = 'C';
        CanMsg.TX_DataBuf[2] = 'A';
        CanMsg.TX_DataBuf[3] = 'C';
        CanMsg.TX_DataBuf[4] = '>';
        CAN_Transmit(2,0x00000001);
    }
    else if(uart_rx_data == 's')
    {
        //printf("s\r\n");
        g_NT_ARSv1_StartFlag = 0;
        CanMsg.DataLength = 5;
        CanMsg.TX_DataBuf[0] = '<';
        CanMsg.TX_DataBuf[1] = 'C';
        CanMsg.TX_DataBuf[2] = 'A';
        CanMsg.TX_DataBuf[3] = 'E';
        CanMsg.TX_DataBuf[4] = '>';
        CAN_Transmit(2,0x00000001);    
    }

}

ISR(CANIT_vect)							//ͷƮ
{
    int i;
    
    if(can_receive(1))
    {
        if(g_NT_ARSv1_StartFlag == 1)
        {
            gc_CanBuf[0] = CanMsg.RX_DataBuf[0];
			gc_CanBuf[1] = CanMsg.RX_DataBuf[1];
			gc_CanBuf[2] = CanMsg.RX_DataBuf[2];
			gc_CanBuf[3] = CanMsg.RX_DataBuf[3];
			gc_CanBuf[4] = CanMsg.RX_DataBuf[4];
			gc_CanBuf[5] = CanMsg.RX_DataBuf[5];
			gc_CanBuf[6] = CanMsg.RX_DataBuf[6];
			gc_CanBuf[7] = CanMsg.RX_DataBuf[7];

			//Roll
			if((gc_CanBuf[0]>>7) == 1)	//
			{
			  	gi_RollBuf = gc_CanBuf[1];		//Roll L BIt
				gi_RollBuf += gc_CanBuf[0]<<8;		//Roll H Bit
				//ni_RollBuf = -(ni_RollBuf&0x7fff);
				gi_RollBuf = (gi_RollBuf&0x7fff);
				gd_Roll = -(((double)(gi_RollBuf)) / 1000.0 * 180.0 / 3.141592);
			}
			else 
			{
			  	gi_RollBuf = (gc_CanBuf[0]<<8);		//Roll H Bit
			  	gi_RollBuf += gc_CanBuf[1];		//Roll L Bit
				gd_Roll = ((double)(gi_RollBuf)) / 1000.0 * 180.0 / 3.141592;
			}			
			//Pitch
			if((gc_CanBuf[2]>>7) == 1)	//
			{
			  	gi_PitchBuf = gc_CanBuf[3];		//Pitch L BIt
				gi_PitchBuf += gc_CanBuf[2]<<8;		//Pitch H BIt
				//ni_PitchBuf = -(ni_PitchBuf&0x7fff);
				gi_PitchBuf = (gi_PitchBuf&0x7fff);
				gd_Pitch = -(((double)(gi_PitchBuf)) / 1000.0 * 180.0 / 3.141592);
			}
			else 
			{
			  	gi_PitchBuf = (gc_CanBuf[2]<<8);	//Pitch H BIt
				gi_PitchBuf += gc_CanBuf[3];		//Pitch L BIt
				gd_Pitch = ((double)(gi_PitchBuf)) / 1000.0 * 180.0 / 3.141592;
			}	
			//Gyro X 
			if((gc_CanBuf[4]>>7) == 1)	//
			{
			  	gi_GyroX_Buf = gc_CanBuf[5];		//GyroX L BIt
				gi_GyroX_Buf += gc_CanBuf[4]<<8;	//GyroX H BIt
				//ni_GyroX_Buf = -(ni_GyroX_Buf&0x7fff);
				gi_GyroX_Buf = (gi_GyroX_Buf&0x7fff);
				gd_GyroX = -(((double)(gi_GyroX_Buf)) / 1000.0 * 180.0 / 3.141592);
			}
			else 
			{
			  	gi_GyroX_Buf = (gc_CanBuf[4]<<8);	//GyroX H BIt
				gi_GyroX_Buf += gc_CanBuf[5];		//GyroX L BIt
				gd_GyroX = ((double)(gi_GyroX_Buf)) / 1000.0 * 180.0 / 3.141592;
			}

			//Gyro Y 
			if((gc_CanBuf[6]>>7) == 1)			//
			{
			  	gi_GyroY_Buf = gc_CanBuf[7];		//GyroY L BIt
				gi_GyroY_Buf += gc_CanBuf[6]<<8;	//GyroY H BIt
				//ni_GyroY_Buf = -(ni_GyroY_Buf&0x7fff);
				gi_GyroY_Buf = (gi_GyroY_Buf&0x7fff);
				gd_GyroY = -(((double)(gi_GyroY_Buf)) / 1000.0 * 180.0 / 3.141592);
			}
			else 
			{
			  	gi_GyroY_Buf = (gc_CanBuf[6]<<8);	//GyroY H BIt
				gi_GyroY_Buf += gc_CanBuf[7];		//GyroY L BIt
				gd_GyroY = ((double)(gi_GyroY_Buf)) / 1000.0 * 180.0 / 3.141592;
			}
			gc_CanCalculationFlag = 1;
        }
        else
        {
            u1_PutChar(CanMsg.RX_DataBuf[0]);
            u1_PutChar(CanMsg.RX_DataBuf[1]);
            u1_PutChar(CanMsg.RX_DataBuf[2]);
            u1_PutChar(CanMsg.RX_DataBuf[3]);
            u1_PutChar(CanMsg.RX_DataBuf[4]);
            u1_PutChar(CanMsg.RX_DataBuf[5]);
            u1_PutChar(CanMsg.RX_DataBuf[6]);
            u1_PutChar(CanMsg.RX_DataBuf[7]);
            printf("\r\n");
        }
    }
}
